# -*- coding: utf-8 -*-
#-------------------------------------------------------------------------------
# Name:        Serveur_bluetooth_sensehat
# Purpose:     Commande du pavé à LED depuis un client Bluetooth
#               Si on reçoit ON on allume, OFF on éteint, END on stappe le serveur
# Author:      Julien Launay
#
# Created:     3/05/2017
# Copyright:   (c) Utilisateur 2017
# Licence:     <your licence>
#-------------------------------------------------------------------------------
import socket
import sys
from sense_hat import SenseHat

sense = SenseHat()
#définition de la couleur des pixels ON et OFF
off = (0,0,0)
on = (255,255,255)
#on remplit 2 matrices 8x8 avec la dalle de LED complète
pixel_on=[on for i in range(64)]
pixel_off=[off for i in range(64)]
#adresse MAC de la carte Bluetooth de votre RaspberryPI3!!
hostMACAddress ='B8:27:EB:13:D2:02'
port = 1
#Nombre de clients qui peuvent se connecter au serveur
nombre_clients = 1 #on se limite à 1 client à la fois pour commencer
size = 1024 #nombre d'octet(s) reçus à la fois
s = None
etat_serveur=True #True = serveur fonctionne et lit, False=serveur arrêté
print ("Commande du pavé à LED du SenseHat via client Bluetooth")

def connexion_bleutooth(): #permet d'attendre la connexion à un client Bluetooth
    global client
    try:
        # On cree un socket Bluetooth
        s = socket.socket(socket.AF_BLUETOOTH, socket.SOCK_STREAM, socket.BTPROTO_RFCOMM)
		# On s'associe au port
        server_address = (hostMACAddress, port)
        s.bind(server_address)
        s.listen(nombre_clients)
        print('On attend un client Bluetooth')
        client, client_address = s.accept()
        print('Adresse MAC du client =' + str(client_address))

    except socket.error as e:
        if s:
            s.close()
        print("Erreur: On ne peut pas creer le socket: " + str(e))
        sys.exit(1)

#programme principal
connexion_bleutooth()  #on attend la connexion d'un client Bluetooth
while etat_serveur: #tant que le serveur est en marche
    donnees_recues = client.recv(size) #on lit les données reçues

    #On prend des decisions en fonction de la commande recue par le client
    if donnees_recues == 'ON':
        print("led allumee")
        sense.set_pixels(pixel_on)
    elif donnees_recues == 'OFF':
        print("led eteinte")
        sense.set_pixels(pixel_off)
    elif donnees_recues == 'END':
        print("arret du serveur")
        etat_serveur=False
        break
    else:
        print("Erreur de commande")


print("Communication stoppée")
client.close()